(******** MODULO DE IMPLEMTACION DE LAS OPERACIONES DE CADENAS *************)

IMPLEMENTATION MODULE cadenas;
IMPORT IO;
IMPORT Window;
CONST
    terminador=CHR(0);

(* FUNCION PARA EL CALCULO DE LA LONGITUD *)

PROCEDURE Longitud(cad:ARRAY OF CHAR):INTEGER;
VAR
  i:CARDINAL;

BEGIN
    i:=1;
    WHILE (i<=HIGH(cad)) AND (cad[i]<>terminador)  DO
          INC(i);
    END;
    RETURN(i);
END Longitud;

(* FUNCION LA COMPARACION DE DOS CADENAS *)
(* DEVUELVE:                             *)
(*    0----------- cad1=cad2             *)
(*    1----------- cad1>cad2             *)
(*    2----------- cad2>cad1             *)


PROCEDURE Comparar(cad1,cad2:ARRAY OF CHAR):CARDINAL ;
VAR
  iguales:CARDINAL;
  i:CARDINAL;
BEGIN
    i:=1;
    iguales:=0;
    IF (Longitud(cad1)=Longitud(cad2)) THEN
           WHILE (i<=HIGH(cad1)) AND  (cad1[i]<>terminador) AND (iguales=0) DO

             IF  (CAP(cad1[i])=CAP(cad2[i])) THEN
                 INC(i);

             ELSE
                iguales:=1;

             END;
       END;
    ELSE
       iguales:=1;
    END;
    RETURN(iguales);
END Comparar;

(* PROCEDIMIENTO PARA COPIAR DOS CADENAS*)

PROCEDURE Copiar(VAR cad1,cad2:ARRAY OF CHAR);
VAR
  i:CARDINAL;

BEGIN
    i:=1;
    WHILE (i<=HIGH(cad1)) AND (i<=HIGH(cad2)) AND (cad1[i]<>terminador) DO
          cad2[i]:=cad1[i];
          INC(i);

    END;
    IF i<=HIGH(cad2) THEN
       cad2[i]:=terminador;

    END;

END Copiar;

(* PROCEDIMIENTO QUE LEE EL DATO DE DNI *)

PROCEDURE LeerDni(VAR c:TDni);
VAR
  i,N:CARDINAL;
  a:CHAR;
  nega:BOOLEAN;
  pausa:CHAR;
BEGIN
    REPEAT
    Window.GotoXY(25,14);
    i:=1;
    N:=8;
    nega:=FALSE;(* VARIABLE BOOLEANA QUE CONTROLA LA CORRECTA INSERCION *)
    IO.RdLn;
    a:=IO.RdChar();
    WHILE (a<>CHR(13)) AND (i<=N) DO
          IF   (ORD(a)<48) OR (ORD(a)>57) THEN
               nega:=TRUE;(* SE ACTIVA PARA INDICAR QUE SE A INSERTADO UN CARACTER NO NUMERICO *)
          ELSE
              c[i]:=a;
              INC(i);
          END;

          a:=IO.RdChar();
     END;
     (* GENERACION DE MENSAJE DE ERROR *)
     IF nega THEN
        Window.GotoXY(21,16);IO.WrStr("Dni incorrecto");
        IO.RdLn;
        pausa:=IO.RdKey();
        Window.GotoXY(21,16);IO.WrStr("              ");
     END;
     UNTIL nega=FALSE;

     IF i<=N THEN
        c[i]:=terminador;
     END;


END LeerDni;
(* FUNCION DE COMPARACION DE DNI*)
(*DEVUELVE:                     *)
(*   TRUE------- IGUALES        *)
(*   FALSE------ NO IGUALES     *)

PROCEDURE CompaDni(d1,d2:TDni):BOOLEAN;
VAR
 Iguales:BOOLEAN;
 i:CARDINAL;

BEGIN
    Iguales:=TRUE ;
    i:=1;
    IF Longitud(d1)=Longitud(d2) THEN
       WHILE (i<=HIGH(d1)) AND (d1[i]<>terminador) AND (Iguales) DO
             IF (d1[i]<d2[i]) OR (d1[i]>d2[i]) THEN
                Iguales:=FALSE   ;
             ELSE
                INC(i);
             END;
        END;
     ELSE
        Iguales:=FALSE;
     END;
     RETURN(Iguales);

END CompaDni;
(* PROCEDIMIENTO PARA ESCRIBIR EN PANTALLA EN DNI*)
PROCEDURE EscribirDni(d:TDni);
VAR
i:CARDINAL;
l:CARDINAL;
BEGIN
    l:=Longitud(d);
    FOR i:=1 TO l DO
        IO.WrChar(d[i]);
    END;

END EscribirDni;


END cadenas.








