(*-------------------- PROGRAMA PRINCIPAL -----------------------------------*)
MODULE Menu;
IMPORT IO;(* TRATAMIENTO DE LECTURA/ESCRITURA *)
IMPORT Window;(* LIBRERIA DE MANEJO DE PANTALLA *)
IMPORT cadenas;(* MODULO DE MANEJO DE CADENAS *)
IMPORT Biblio;(* MODULO DE MANEJO DE LA ESTRUCTURA DE DATOS *)
IMPORT FIO;(* LIBRERIA DE MANEJO DE FICHEROS *)

(* PROCEDIMIENTO QUE CHEQUEA LOS ERRORES *)

PROCEDURE Error(er:Biblio.TError);
VAR
  i:CARDINAL;
  pausa:CHAR;
BEGIN
    IF er<>Biblio.ok THEN
       Window.Clear();
       Window.GotoXY(20,12);IO.WrStr("");
       Window.GotoXY(53,12);IO.WrStr("");
       Window.GotoXY(20,13);IO.WrStr("");
       Window.GotoXY(53,13);IO.WrStr("");
       Window.GotoXY(20,14);IO.WrStr("");
       Window.GotoXY(53,14);IO.WrStr("");
       Window.GotoXY(53,15);IO.WrStr("");
       Window.GotoXY(20,15);IO.WrStr("");
       Window.GotoXY(20,16);IO.WrStr("");
       Window.GotoXY(53,16);IO.WrStr("");
       FOR i:=21 TO 52 DO
            Window.GotoXY(i,12);IO.WrStr("");
            Window.GotoXY(i,14);IO.WrStr("");
            Window.GotoXY(i,16);IO.WrStr("");
       END;
       Window.GotoXY(21,13);IO.WrStr("     *****  ERROR  *****");
       Window.GotoXY(21,18);IO.WrStr("   --Pulse cualquier tecla --");
       Window.GotoXY(22,15);
       CASE er OF
              Biblio.Nomemoria:IO.WrStr("NO HAY MEMORIA DISPONIBLES");|
              Biblio.Libronoesta:IO.WrStr("EL LIBRO NO EXISTE");|
              Biblio.Dninoesta:IO.WrStr("EL DNI ES INCORRECTO");|
              Biblio.ListaVacia:IO.WrStr("NO HAY REGISTROS EN LA LISTA");|
              Biblio.NoejemplaresDisponibles:IO.WrStr("NO HAY EJEMPLARES DISPONIBLES");|
       END;
       IO.RdLn;
       pausa:=IO.RdKey();

   END;
END Error;

(* GENERACION DE LA PANTALLA UTILIZADA EN LAS DIFERENTES OPCIONES *)

PROCEDURE Pantalla();
VAR
i:CARDINAL;
BEGIN
    Window.Clear();
    Window.GotoXY(20,9);IO.WrStr("");
    Window.GotoXY(20,10);IO.WrStr("");
    Window.GotoXY(54,10);IO.WrStr("");
    Window.GotoXY(20,11);IO.WrStr("");
    Window.GotoXY(54,9);IO.WrStr("");
    Window.GotoXY(20,10);IO.WrStr("");
    Window.GotoXY(54,10);IO.WrStr("");
    Window.GotoXY(54,11);IO.WrStr("");
    Window.GotoXY(20,15);IO.WrStr("");
    Window.GotoXY(54,15);IO.WrStr("");
    FOR i:=21 TO 53 DO
        Window.GotoXY(i,9);IO.WrStr("");
        Window.GotoXY(i,11);IO.WrStr("");
        Window.GotoXY(i,15);IO.WrStr("");
    END;
    FOR i:=12 TO 14 DO
        Window.GotoXY(20,i);IO.WrStr("");
        Window.GotoXY(54,i);IO.WrStr("");
    END;


END Pantalla;

(* PROCEDIMIENTO DE INSERCCION DE NUEVO LIBRO *)

PROCEDURE OpcionA(VAR biblio:Biblio.PuntLibro);
VAR
  titulo,autor:cadenas.Tcadenas;
  exis,i:INTEGER;
  error:Biblio.TError;
BEGIN
    error:=Biblio.ok;
    Pantalla();
    Window.GotoXY(21,10);IO.WrStr("Opcion A - Insetar nuevo libro -");
    Window.GotoXY(21,12);IO.WrStr ("Titulo:");IO.RdStr(titulo);
    Window.GotoXY(21,13);IO.WrStr ("Autor:");IO.RdStr(autor);
    Window.GotoXY(21,14);IO.WrStr ("N De Ejemplares: ");exis:=IO.RdInt();

    (* CHEQUE DE CORRECTA INSERCCION DE N DE EJEMPLARES *)

    IF (exis=0) AND NOT(IO.OK) THEN
       Window.GotoXY(21,17);IO.WrStr("Atencion:");
       Window.GotoXY(21,18);IO.WrStr(" El dato inseratado en incorrecto, el");
       Window.GotoXY(21,19);IO.WrStr(" o el n de ejemplares debe ser mayor de 0");
       WHILE (exis<=0) AND NOT(IO.OK) DO
             Window.GotoXY(39,14);
             IO.RdLn;
             exis:=IO.RdCard();
       END;

    END;

    (*LLAMADA AL PROCEDIMIENTO DE INSERTAR NUEVO DATO EN LA ESTRUCTURA *);

    Biblio.Insertar(biblio,titulo,autor,exis,error);

    Error(error);(*CHEQUEO DE ERROR*);
END OpcionA;

(* OPCION DE PRESTAMO DE LIBRO *)

PROCEDURE OpcionB(VAR biblio:Biblio.PuntLibro);
VAR
  titulo,nombre:cadenas.Tcadenas;
  dni:cadenas.TDni;
  error:Biblio.TError;
BEGIN
    error:=Biblio.ok;
    Pantalla();
    Window.GotoXY(21,10);IO.WrStr("Opcion B - Prestar un Libro -");
    Window.GotoXY(21,12);IO.WrStr ("Titulo:");IO.RdStr(titulo);
    Window.GotoXY(21,13);IO.WrStr ("Nombre:");IO.RdStr(nombre);
    Window.GotoXY(21,14);IO.WrStr ("Dni:");cadenas.LeerDni(dni);

    (* LLAMADA AL PROCEDIMIENTO DE INSERCCION DE NUEVO PRESTAMO *);

    Biblio.Presta(biblio,titulo,nombre,dni,error);

    Error(error);(*CHEQUEO DE ERROR*);
END OpcionB;

(*PROCEDIMIENTO DE DEVOLUCION DE LIBRO *)

PROCEDURE OpcionC(VAR biblio:Biblio.PuntLibro);
VAR
 dni:cadenas.TDni;
 titulo:cadenas.Tcadenas;
 error:Biblio.TError;

BEGIN
    error:=Biblio.ok;
    Pantalla();
    Window.GotoXY(21,10);IO.WrStr("Opcion C - Devolver un ejemplar -");
    Window.GotoXY(21,12);IO.WrStr ("Titulo: ");IO.RdStr(titulo);IO.WrLn;
    Window.GotoXY(21,14);IO.WrStr ("Dni:");cadenas.LeerDni(dni);

    (*LLAMADA AL PROCEMIDIENTO DE DEVOLUCIO DE UN LIBRO *);

    Biblio.Devolver(biblio,dni,titulo,error);

    Error(error);(*CHEQUEO DE ERRORES*);
END OpcionC;


(* OPCION DE LISTADO POR PANTALLA *)

PROCEDURE OpcionD(biblio:Biblio.PuntLibro);
VAR
  error:Biblio.TError;
  a:CHAR;
BEGIN
    error:=Biblio.ok;
    (*LLAMA AL PROCEDIMIENTO DE LISTAR EL TAD*);

    Biblio.Listar(biblio,error);

    IF error=Biblio.ok THEN
         (*MENSAJE DE ESPERA,PARA BORRAR LA PANTALLA AL FINALIZAR EL LISTADO*)

        Window.GotoXY(2,24);IO.WrStr("Pulse cualquier tecla para continuar");
        WHILE NOT(IO.KeyPressed()) DO
        END;
    END;
    Error(error);(*CHEQUEO DE ERROR*);

END OpcionD;

(* PROCEDIMIENTO DE LA OPCION DE REGALO DE LIBRO A CLIENTES *)

PROCEDURE OpcionG(VAR biblio:Biblio.PuntLibro);
VAR
  titulo:cadenas.Tcadenas;
  error:Biblio.TError;

BEGIN
    error:=Biblio.ok;
    Pantalla();
    Window.GotoXY(21,10);IO.WrStr("Opcion  G -Regalar un ejemplar -");
    Window.GotoXY(21,12);IO.WrStr ("Titulo:");IO.RdStr(titulo);

    (* LLAMA AL PROCEDIMIENTO DE REGALO *);

    Biblio.Regalo( biblio,titulo,error);
    Error(error);(*CHEQUEO DE ERROR*);
END OpcionG;

(* PROCEDIMIENTO DE VOLCADO DE DATOS A FICHERO *)

PROCEDURE OpcionE(biblio:Biblio.PuntLibro);
VAR
  a:CHAR;
  error:Biblio.TError;
BEGIN
    error:=Biblio.ok;
    Window.Clear();
    (*COMPROBACION DE LA EXISTENCIA DEL FICHERO *);

    IF FIO.Exists("Datos.dat") THEN
       (* PETICION DE SOBREESCRITURA *);

       Pantalla();
       Window.GotoXY(21,10);IO.WrStr("Opcion E -Volcar a fichero - ");
       Window.GotoXY(21,12);IO.WrStr("EL FICHERO YA EXISTE");
       Window.GotoXY(21,13);IO.WrStr("DESEA SOBREESCRIBIR");
       Window.GotoXY(21,14);IO.WrStr("S/N: ");
       Window.GotoXY(26,14);
       IO.RdLn;
       a:=CAP(IO.RdChar());

       (* VALIDACION DE LA OPCION*);

       WHILE (a<>"S") AND (a<>"N") DO
          Window.GotoXY(21,16);IO.WrStr(" Opcion incorrecta ");
          Window.GotoXY(26,14);
          a:=CAP(IO.RdChar());
       END;
       IF a="S" THEN
          Biblio.VolcarAfichero(biblio,"Datos.dat",error);
       END;
     ELSE
        Biblio.VolcarAfichero(biblio,"Datos.dat",error);
     END;
     Error(error);(*CHEQUEO DE ERROR*)

END OpcionE;

(*PROCEDIMIENTO DE LECTURA DESDE FICHERO *)

PROCEDURE OpcionF(VAR biblio:Biblio.PuntLibro);
VAR
  error:Biblio.TError;
  a:CHAR;
BEGIN
    error:=Biblio.ok;
    (*COMPROVACION DE LA EXISTENCIA DEL FICHERO *);

    IF NOT(FIO.Exists("Datos.dat"))     THEN
       Pantalla();
       Window.GotoXY(21,10);IO.WrStr("Opcion F - Calgar TAD de Fichero ");
       Window.GotoXY(21,13);IO.WrStr(" EL FICHERO NO EXISTE ");
       IO.RdLn;
       a:=IO.RdKey();

    ELSE
        Biblio.CrearDeFichero(biblio,"Datos.dat",error);
    END;
    Error(error); (*CHEQUEO DE ERROR*);
END OpcionF;

(*PROCEDIMIENTO DE SALIDA*)

PROCEDURE OpcionH():BOOLEAN;
VAR
 op:CHAR;
 pausa:CHAR;
BEGIN
    Window.CursorOn;
    Window.Clear();
    (* GENERACION DE LA PANTALLA *)

    Window.GotoXY(26,8);IO.WrStr ("ͻ");
    Window.GotoXY(26,9);IO.WrStr ("    DESEA SALIR ?    ");
   Window.GotoXY(26,10);IO.WrStr ("͹");
   Window.GotoXY(26,11);IO.WrStr ("    Si         No    ");
   Window.GotoXY(26,12);IO.WrStr ("͹");
   Window.GotoXY(26,13);IO.WrStr (" Opcion:              ");
   Window.GotoXY(26,14);IO.WrStr ("ͼ");
   Window.GotoXY(38,13);
   IO.RdLn;
   op:=IO.RdChar();
   op:=CAP(op);
   (* VALIDACION DE LA OPCION *);

   WHILE (op<>"S") AND (op<>"N") DO

         Window.GotoXY(26,16);IO.WrStr ("*** OPCION INCORRECTA ***");
         IO.RdLn;
         pausa:=IO.RdKey();
         Window.GotoXY(38,13);IO.WrStr ("     ");

         Window.GotoXY(26,16);IO.WrStr ("                         ");
         Window.GotoXY(38,13);
         op:=IO.RdChar();
         op:=CAP(op);
   END;
   IF op="S" THEN
      RETURN(TRUE);
   ELSE
      RETURN(FALSE);
   END;
   Window.CursorOn;
END OpcionH;

(* PROGRAMA PRINCIPAL *)

VAR
  salir:BOOLEAN;
  opcion:CHAR;
  biblio:Biblio.PuntLibro;
  prue,pru2:cadenas.TDni;
  ok:BOOLEAN;

BEGIN
    Biblio.Crear(biblio);
    salir:=FALSE;
    REPEAT
    (* GENERACION DEL MENU PRINCIPLA *);
    Window.Clear();
    Window.GotoXY(28,3);IO.WrStr ("ͻ");
    Window.GotoXY(28,4);IO.WrStr ("      BIBLIOTECA     ");
    Window.GotoXY(28,5);IO.WrStr (" MENU PRINCIPAL ͹");
    Window.GotoXY(28,6);IO.WrStr ("                     ");
    Window.GotoXY(28,7);IO.WrStr (" A... Insertar Libro ");
   Window.GotoXY(28,8);IO.WrStr ("                     ");
   Window.GotoXY(28,9);IO.WrStr (" B... Prestar Libro  ");
   Window.GotoXY(28,10);IO.WrStr ("                     ");
   Window.GotoXY(28,11);IO.WrStr (" C... Devolver Libro ");
   Window.GotoXY(28,12);IO.WrStr ("                     ");
   Window.GotoXY(28,13);IO.WrStr (" D... Listar TAD     ");
   Window.GotoXY(28,14);IO.WrStr ("                     ");
   Window.GotoXY(28,15);IO.WrStr (" E...Volcar Tad a Fi ");
   Window.GotoXY(28,16);IO.WrStr ("                     ");
   Window.GotoXY(28,17);IO.WrStr (" F...Cargar fic a Ta ");
   Window.GotoXY(28,18);IO.WrStr ("                     ");
   Window.GotoXY(28,19);IO.WrStr (" G... Regalo         ");
   Window.GotoXY(28,20);IO.WrStr ("                     ");
   Window.GotoXY(28,21);IO.WrStr (" H... Salir          ");
   Window.GotoXY(28,22);IO.WrStr ("                     ");
   Window.GotoXY(28,23);IO.WrStr ("͹");
   Window.GotoXY(28,24);IO.WrStr ("Opcion:              ");
   Window.GotoXY(28,25);IO.WrStr ("ͼ");
   Window.GotoXY(38,24);opcion:=CAP (IO.RdChar());
   CASE opcion OF
        "A":OpcionA(biblio);|
        "B":OpcionB(biblio);|
        "C":OpcionC(biblio);|
        "D":OpcionD(biblio);|
        "E":OpcionE(biblio);|
        "F":OpcionF(biblio);|
        "G":OpcionG(biblio);|
        "H":salir:=OpcionH();|
    END;
    UNTIL salir;
    Biblio.Destruir(biblio);(*SE DESTRUYE LA ESTRUCTURA CREADA*)
END Menu.
